import { useEffect, useRef } from "react";
import getOr from "lodash/fp/getOr";
import isNumber from "lodash/fp/isNumber";
import useToggle from "../toggle";
export var useInterval = function (fn, opts) {
    var delay = isNumber(opts) ? opts : getOr(1000, "delay", opts);
    var autoStart = getOr(false, "autoStart", opts);
    var timeout = useRef(null);
    var _a = useToggle(autoStart), isIntervalOn = _a[0], toggleInterval = _a[1];
    useEffect(function () {
        function clearTimeoutSafe() {
            timeout.current && clearTimeout(timeout.current);
            timeout.current = null;
        }
        if (isIntervalOn) {
            timeout.current = setInterval(fn, delay);
        }
        else {
            clearTimeoutSafe();
        }
        return function () {
            clearTimeoutSafe();
        };
    }, [delay, fn, isIntervalOn]);
    return [isIntervalOn, toggleInterval];
};
export default useInterval;
//# sourceMappingURL=interval.js.map